package fr.inra.pappso.pipeline;

import java.io.File;
import java.io.Serializable;

import org.apache.log4j.Logger;

import fr.inra.pappso.pep_exception.PepException;

public class fasts_conf implements Serializable {
	private static final Logger logger = Logger.getLogger(fasts_conf.class);

	private static final long serialVersionUID = 1321551L;

	File outdir;

	File dataout;

	File database_conta;

	File database_interest;

	File fasts_exec;

	int pepnovo_score;

	int thread;

	public fasts_conf() throws PepException {
		this.pepnovo_score = 100;
		this.thread = 1;
		this.initialise();
	}

	private void initialise() throws PepException {
		// TODO Auto-generated method stub
		if (System.getProperty("os.name").contains("Windows")) {
			database_conta = new File("C:/Benperl/contaminants_standarts.fasta");
			fasts_exec = new File("C:/Benperl/Fasta/fasts36.exe");
		} else if (System.getProperty("os.name").contains("Linux")) {
			database_conta = new File("/opt/contaminants_standarts.fasta");
			fasts_exec = new File("/usr/bin/fasts36");// "/opt/fasta/fasts34");
		} else
			throw new PepException(System.getProperty("os.name")
					+ " is not compatible with this java application");
		if (!fasts_exec.exists())
			throw new PepException("The Fasts software : "
					+ fasts_exec.getAbsolutePath()
					+ " is not present on your system");
		logger.debug("New Fasts config file");
	}

	public int getThread() {
		return thread;
	}

	public void setThread(int thread) {
		if (thread > 0)
			this.thread = thread;
	}

	public File getDataout() {
		return dataout;
	}

	public void setDataout(File dataout) {
		this.dataout = dataout;
		this.outdir = this.dataout.getParentFile();
	}

	public File getFasts_exec() {
		return fasts_exec;
	}

	public void setFasts_exec(File fasts_exec) throws PepException {
		this.fasts_exec = fasts_exec;
		if (!fasts_exec.exists())
			throw new PepException("The Fasts software : "
					+ fasts_exec.getAbsolutePath()
					+ " is not present on your system");

	}

	public File getOutdir() {
		return outdir;
	}

	public File getDatabase_conta() {
		return database_conta;
	}

	public void setDatabase_conta(File databases_1) {
		this.database_conta = databases_1;
	}

	public File getDatabase_interest() {
		return database_interest;
	}

	public void setDatabase_interest(File databases_2) {
		this.database_interest = databases_2;
	}

	public int getPepnovo_score() {
		return pepnovo_score;
	}

	public void setPepnovo_score(int pepnovo_score) {
		this.pepnovo_score = pepnovo_score;
	}

}
