package fr.inra.pappso.sax_parse;

import fr.inra.pappso.pep_exception.PepException;

public class Spectrum_decode {
	boolean isPrecision64;
	int length;
	boolean bigendian;
	
	public Spectrum_decode(){
		isPrecision64 = false;
		bigendian = true;
	}
	
	public void set_isPrecision64 (int I){
		if (I == 64)
		this.isPrecision64 = true;
	}
	
	public void set_byteorder (String S){
		if (!S.equals("network"))
		this.bigendian = false;
	}
	public void test_pair_order (String S) throws PepException {
		if (S==null)
			throw new PepException("Tag 'pairOrder' not present");
		else if (!S.equals("m/z-int"))
			throw new PepException("Invalid pairOrder value: "+S);
	}
	
	public float[] parseBinary(String data) throws PepException {
		byte[] binary = Base64.decode(data, Base64.NO_OPTIONS);
		
		length = binary.length / (isPrecision64 ? 8 : 4 );

		if (binary.length < length * (isPrecision64 ? 8 : 4 ))
			throw new ArrayIndexOutOfBoundsException();
		
		float ret[] = new float[length];
		
		if (isPrecision64) {
			// 64: long to double
			final int precision = 8, precisionMinus1 = 7, precisionbits = 3;
			
			for (int i = 0; i < length; i++) {
				long bits = 0;
				for (int j = 0; j < precision; j++) {
					bits |= ((long) binary[(i << precisionbits) + 
					                       (bigendian?precisionMinus1-j:j)]
								& 0xFF) << (j << 3);
				}
				ret[i] = (float) Double.longBitsToDouble(bits);
			}
		} else {
			// 32: int to float to double
			final int precision = 4, precisionMinus1 = 3, precisionbits = 2;
			
			for (int i = 0; i < length; i++) {
				int bits = 0;
				for (int j = 0; j < precision; j++) {
					bits |= ((int) binary[(i << precisionbits) + 
					                      (bigendian?precisionMinus1-j:j)]
								& 0xFF) << (j << 3);
				}
				ret[i] = Float.intBitsToFloat(bits);
			}
		}
		
		return ret;
	}
	
	
	
	
}
