package fr.inra.pappso.sax_parse;

import org.apache.log4j.Logger;
import org.xml.sax.*;

import fr.inra.pappso.DeNovo_pipeline;
import fr.inra.pappso.class_pep.Ms_run;
import fr.inra.pappso.class_pep.Spectre;
import fr.inra.pappso.class_pep.seq_prot;
import fr.inra.pappso.pep_exception.PepException;

public class tandem_to_pepnovo_parse extends org.xml.sax.helpers.DefaultHandler {
	private static final Logger logger = Logger
			.getLogger(tandem_to_pepnovo_parse.class);

	private Spectre spectre_;

	private Ms_run msrun_;

	private String Last_element_;

	private String Start_element_;

	private String C_data;

	private int _scan;

	private String _sample;

	private boolean good_sample;

	private seq_prot prot_;

	public tandem_to_pepnovo_parse(Ms_run msrun, String sample) {
		super();
		msrun_ = msrun;
		_sample = sample;
	}

	// Les methodes qui suivent sont appelées
	// automatiquement par l'analyseur
	// lorsqu'un événement est détecté
	// dans le fichier XML.
	public void error(SAXParseException e) throws SAXParseException {
		throw (e);
	}

	public void startDocument() throws SAXException {
		Last_element_ = "";
		Start_element_ = "";
		C_data = "";
		_scan = 0;
		good_sample = false;
		// prot_ = new seq_prot();
		// identification_.add_sample(sample_.getName());
	}

	public void endDocument() throws SAXException {
		// System.out.println("fin du document");
	}

	public void startElement(String namespaceURI, String simpleName,
			String qualifiedName, Attributes attrs) throws SAXException {

		Start_element_ = simpleName;
		if (Start_element_.equals(""))
			Start_element_ = qualifiedName;

		if (Start_element_.equals("sample")) {
			if (attrs.getValue("file").equalsIgnoreCase(_sample + ".xml"))
				good_sample = true;
			else if (attrs.getValue("file").equalsIgnoreCase(_sample))
				good_sample = true;
			else
				good_sample = false;
		}

		if (Start_element_.equals("protein")) {
			prot_ = new seq_prot();
			prot_.set_description(attrs.getValue("desc"));
			prot_.setNumber(attrs.getValue("nb"));
			prot_.setPeptides(Integer.parseInt(attrs.getValue("pep")));
		}

		if (Start_element_.equals("scan")) {
			_scan = Integer.parseInt(attrs.getValue("nb"));
			if (good_sample) {
				logger.debug(_sample + _scan);
				try {
					spectre_ = msrun_.get_spectra_to_scan("" + _scan);
				} catch (PepException e) {
					throw new SAXException(e);
				}
				spectre_.set_Identified(true);
			}
		}

		C_data = "";
	}

	public void endElement(String namespaceURI, String simpleName,
			String qualifiedName) throws SAXException {
		Last_element_ = simpleName;
		if (Last_element_.equals(""))
			Last_element_ = qualifiedName;

		if (Last_element_.equals("sequence")) {
			prot_.set_sequence(C_data);
		}

		if (Last_element_.equals("protein")) {
			if ((!msrun_.is_protein_exist(prot_)) & good_sample)
				msrun_.add_xtandem_prot(prot_);
		}

		C_data = "";
	}

	public void characters(char buf[], int offset, int len) throws SAXException {
		C_data = C_data + new String(buf, offset, len);
		// System.out.println(C_data);
	}

}
