package fr.inra.pappso.shell;

import java.util.regex.*;

import org.apache.log4j.Logger;

import fr.inra.pappso.class_pep.Ms_run;
import fr.inra.pappso.class_pep.Spectre;
import fr.inra.pappso.pep_exception.PepException;

public class pepnovo_filter extends base_shell {
	private static final Logger logger = Logger.getLogger(pepnovo_filter.class);

	private Pattern regex_scan;

	private Pattern regex_result;

	private Ms_run run;

	private Spectre spectre_run;

	private int count;

	public pepnovo_filter() {
		super();
		// regex_result = Pattern.compile("^\\d+\\.\\d+$");
		regex_result = Pattern.compile("^SQS: (\\d+\\.\\d+).*$");
		regex_scan = Pattern.compile("^\\>\\>*");
		count = 0;
	}

	public void processing(String mess) {
		// analyse du flux de sortie de l'application
		try {
			logger.debug(mess);
			Matcher resultat_scan = regex_scan.matcher(mess);
			if (resultat_scan.find()) {
				String[] scan = mess.split(".mzXML_");
				// System.out.print(scan[1] + " ");
				spectre_run = run.get_spectra_to_scan(scan[1]);
				count++;

			} else {
				Matcher resultat_filter = regex_result.matcher(mess);
				if (resultat_filter.find()) {
					{
						// System.out.println(resultat_filter.group());
						// System.out.println(resultat_filter.group(1));
						// spectre_run.set_quality_score((float) 0.8);
						spectre_run.set_quality_score(Float.valueOf(
								resultat_filter.group(1)).floatValue());
					}
				}
			}
		} catch (PepException e) {
			this.set_error("" + e);
		}
	}

	public void set_Msrun(Ms_run run) {
		this.run = run;
	}

	public void test_result() {
		if (count == 0)
			this.set_error("Error during pepnovo filter analysis\n"
					+ this.get_Stdout());
	}

}
